#!/usr/bin/perl

$infile = $ARGV[0];
#$outfile = $infile;
#$outfile =~ s/\.txt$//i;
#$outfile .= ".spm";

open(IN,$infile);

$line=0; #line in the file, starts at 1
%words;
while (<IN>){
    chomp;
    while(/(\w+)/g){
	my $w=lc($1);
	next if $w eq "england";
	if(!exists $words{$w}){
	  $words{$w}=[$line];
      }
	else{
	    push(@{$words{$w}},$line);
	}
    }
    $line++;
}

$nnz=0;
print "$line $line 0\n";
open DEST,"|sort -n -k 2| sort -n -s|uniq -c|./reorder_cols.pl"; #terrible performance
while (($w,$a)=each(%words)){
    while($link1=pop @$a){
	foreach $link2 (@$a){
	    print DEST "$link1 $link2\n";
	    print DEST "$link2 $link1\n";
	}
	print DEST "$link1 $link1\n"; #counts self-similarity
    }
}
close DEST;
